ASMB,R,C
      HED TIMESHARE COPY OF 'RND' FUNCTION--FTN CALLABLE
*THE RANDOM NUMBER FUNCTION COMPUTES A RANDOM NUMBER FROM THE 
*FORMULAS:
* 
*    X(N)=A*X(N-1)+C(MOD 2^30)    (A=5^11,C=2^30*(1/2-1/SQR(12))) 
*    RND=X/2^30  MIN  (1-2^-23) 
* 
      NAM RND,7 
      ENT RND 
      EXT .PACK,.ENTR 
      SPC 1 
ARGU  NOP          PARAMETER ADDRESS
RND  NOP
      JSB .ENTR    GET PARAMETER ADDRESS
      DEF ARGU     TOP OF STACK 
      DLD ARGU,I   GET PARAMETER
      SSA,RSS       POSITIVE ARGUMENT?
      JMP ERND1     YES, USE PREVIOUS VALUE 
      RBL,CLE,ERB   NO, MAKE A
      ELA           NEW SEED
      STA RNDX1      MSB NEW SEED (DLB) 
      STB RNDX2      SAVE LSB NEW SEED
ERND1 LDA RNDX1    (DLB)
      MPY RNDA2     1ST CROSS PRODUCT 
      STA RNDX1 
      LDA RNDX2     2ND CROSS PRODUCT 
      MPY RNDA1 
      ADA RNDX1      ADD IN FIRST 
      ADA RNDC1      ADD IN HIGH PART OF C
      STA RNDX1      SAVE TOTAL (THIS IS HIGH PART) 
      CLE            (DLB) MOD ALSO 7/24/72 
      LDA RNDX2      COMPUTE LOW ORDER PRODUCT
      MPY RNDA2 
      ADA RNDC2      ADD IN LOW PART OF C 
      SEZ 
      INB 
      RAL,CLE,ERA    E_A(15Z,A(15)_0
      STA RNDX2      SAVE LOW ORDE R RESULT 
      ELB             SHIFT HIGH ORDER PART 
      ADB RNDX1       ADD IN PRIEVIOUS TOTAL
      ELB,CLE,ERB    CLEAR BIT 15 
      STB RNDX1 
      RAL            SHIFT A ADJUCENT TO B
      STA RNDB1      EXCHANGE 
      STB A           A 
      LDB RNDB1      REGISTERS
      JSB .PACK 
      OCT 0        EXPONENT IS 0
      CPB D2         TEST FO R RESULT T=1.0 
      RSS 
      JMP RND,I      EXIT IF NOT
      LDA INF         SET RESULT TO 1-2^-23 
      LDB M256
      JMP RND,I 
D2    DEC 2 
RNDA1 DEC 1490        A DIV 2^15
RNDA2 DEC 3805        A MOD 2^15
RNDB1 OCT 0 
RNDC1 OCT 16441       C DIV 2^15
RNDC2 OCT 7701        C MOD 2^15
INF   OCT 77777 
M256  DEC -256
RNDX1 OCT 0 
RNDX2 OCT 0 
A     EQU 0    A-REG DEFINITION 
      END 
